package Config;

sub _dump {
    require Data::Dumper;
    return Data::Dumper::Dumper(shift);
}

sub _sort_items {
    my ($data) = @_;
    my ($items) = $data =~ /\{(.+?)\s*\};?\s*\z/s;
    $items .= ',';
    $data = 'scalar {' . join("\n", (sort { lc $a cmp lc $b }
                               split(/\n/, $items, 0))) . "\n};\n";

    $data =~ s{=>\s*'(\d+)',\s*$}  {=> $1,}gm;
    $data =~ s{(.+?)\s*=>\s*(.+)}{
        sprintf '%s%*s', $1, 45 - length($1) + length($2), ' => ' . $2;
    }egm;
    return $data;
}

sub save_hash {
    my ($file, $config) = @_;
    return unless ref $config eq 'HASH';
    open(my $fh, '>', $file) or return;
    print {$fh} _sort_items(_dump($config));
    close $fh;
    return 1;
}

sub save_plain {
    my ($file, $config_text) = @_;
    my $dump = _dump(eval $config_text);
    die $@ if $@;
    open(my $fh, '>', $file) or return;
    print {$fh} _sort_items($dump);
    close $fh;
    return 1;
}

sub get_config {
    my ($file) = @_;
    my $config;
    open my $fh, '<', $file or return;
    sysread $fh, $config, -s $file;
    close $fh;
    return $config;
}

1;
